#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_UseUpx=y
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.14.2
 Author:         aldoniel

 Script Function:

	add batch file encoding to avidemux

#ce ----------------------------------------------------------------------------

; Script Start - Add your code below here
#include "ListDir.au3"
#include "Console.au3"



cout('Loading settings from lastconfig.ini. Choose "No" to load other settings'&@LF)
if not entertocontinue() then
	global $inipath=FileOpenDialog("select another ini config file than lastconfig.",@ScriptDir,"ini (*.ini)",3)
	if @error then
		cout("abord"&@LF)
		fin()
	EndIf
	Else
	global $inipath="lastconfig.ini"
EndIf



$ini=IniReadSection($inipath,"global")
if @error Then
	cout("ini read error : please create a correct ini file in the script dir (cf default_config.ini)"&@LF)
	fin()
EndIf

for $i=6 to 7
if StringCompare($ini[$i][1],true) or StringCompare($ini[$i][1],false) Then
	if $i=6 then Global $recursive=Execute($ini[6][1])
	if $i=7 then Global $avidemux_silence=Execute($ini[7][1])
Else
	cout("recursive_analysis_of_input_dir & avidemux_silence must be either true or false")
	fin()
EndIf
next

global const $avidemux=FileGetShortName($ini[3][1])  ;3_1 = avidemux_path
;~ global const $avidemux=FileGetShortName("C:\Program Files\Avidemux 2.7 - 64 bits\avidemux.exe") ; to debug avidemux errors, uncomment this line
if FileExists(@ScriptDir&"\"&$ini[4][1]) then $ini[4][1]=@ScriptDir&"\"&$ini[4][1]
global const $configscript=FileGetShortName($ini[4][1]) ; path to the script.py generated by avidemux

local $a[2]= [$avidemux,$configscript]
for $i in $a
if not FileExists($i) then
	cout($i & " doesn't exist!"&@LF)
	fin()
EndIf
Next
$a=0

if StringCompare($ini[5][1],"same_as_input")=0 then
	global $absolute_output_dir=""
Else
	global $absolute_output_dir=$ini[5][1]
EndIf


;lister les mkv vidéo

do
	if StringCompare($ini[8][1],"ask")=0 then
		$dir=FileSelectFolder ("Please select the folder of the input video " &$ini[1][1]&" files","::{20D04FE0-3AEA-1069-A2D8-08002B30309D}") ;dir = my computer
		if @error then
			cout("Abord."&@LF)
			fin()
		Else
			cout("reading "&$dir&@LF)
			$ini[8][1]=$dir
			FileChangeDir($dir)
		EndIf
	Else
		$dir=$ini[8][1]
	EndIf



	local $filelist=""
	Local $dummydir="" ; ne sera pas utilisé

	cout(@LF)
;~ ListDir($filelist,$dummydir,$dir,"*."&$ini[1][1],$recursive,true) ; don't know why, but avidemux fails without absolute path (cf true) ;  ini[1][1]=mp4
	ListDir($filelist,$dummydir,$dir,"*."&$ini[1][1],$recursive,true) ; don't know why, but avidemux fails without absolute path (cf true) ;  ini[1][1]=mp4
	if (BitAND(@error,2)<>2) then
;~ 		_ArrayDisplay($filelist,"files")
		for $i=0 to UBound($filelist)-1
			cout($filelist[$i]&@LF)
		Next
		cout(@LF&'Please check that these files are correct.'&@LF)
		if entertocontinue() Then
			ExitLoop
		Else
			$ini[8][1]="ask"
		EndIf


	Else
		cout("no file match for "&$ini[1][1]&@LF)
		$ini[8][1]="ask"
	EndIf
Until 0

; on y go

$input_extension_len=StringLen($ini[1][1])

local $ubound=UBound($filelist)-1
for $i=0 to $ubound
	cout(StringFormat("Processing file %i of %i (%i%%)\n",$i+1,$ubound+1,int(100/($ubound+1)*$i+1)))

	if $absolute_output_dir="" then
		$output=StringTrimRight($filelist[$i],$input_extension_len)&$ini[2][1] ; 2_1 = mkv
	Else
		$filename=StringSplit($filelist[$i],"\") ; get filename from path  without regexpr, maybe faster...
		$filename=$filename[$filename[0]]
		$output=$absolute_output_dir&"\"&StringTrimRight($filename,$input_extension_len)&$ini[2][1]
	endif

	if FileExists($output) Then
		$output=StringTrimRight($output,$input_extension_len+1)&@YEAR&@MON&@MDAY&"."&$ini[2][1] ; add day to avoid most overwrites except previous tests
	EndIf
;~ 	$command=StringFormat('%s --load "%s" --run %s --save "%s" --quit',$avidemux,$filelist[$i],$configscript,$output) ; verbose mode
	$command=StringFormat('%s --load "%s" --run %s --save "%s" --quit',$avidemux,$filelist[$i],$configscript,$output)
	if $avidemux_silence then $command&=" >nul" ;silence avidemux_cli ...
	cout($command&@lf)

	system_($command)

	cout(@LF)
Next


if IniWriteSection(@ScriptDir&"\"&"lastconfig.ini","global",$ini) =0 then cout("failed to save default ini config"&@LF)

fin()


Func fin()
	cout(@LF)
	system("pause")
	Exit
EndFunc   ;==>fin


func entertocontinue()
	cout('Press Enter to continue("Yes"), or any other key for "No"'&@LF)

	if asc(Getch())=13 Then ;23 = enter
		Return 1
	Else
		return 0
	EndIf
EndFunc



; ===============================================================================================================================
; #FUNCTION# ====================================================================================================================
; Name...........: system_
; Description ...: Invokes the command processor to execute a command. Once the command execution has terminated, the processor
;				   gives the control back to the program, returning an int value, whose interpretation is system-dependent.
; Syntax.........: system($szCommand)
; Parameters ....: $szString      		- A string containing a system command to be executed.
; Return values .: Success              - Depends on command given.
;                  Failure              - Depends on command given.
; Author ........: Janus Thorborg (Shaggi) modified aldoniel : changed @ScriptDir to @WorkingDir
; Modified.......: Le 14/04/2018 à 23h33
; Remarks .......: Common use is system("pause") or system("cls").
; Related .......: RunWait
; Link ..........: http://www.cplusplus.com/reference/clibrary/cstdlib/system/
; Example .......: No
; ===============================================================================================================================
Func system_($szCommand)
	If $szCommand Then
		If Not $__Amount__Startup_Console Then
			__Console__CreateConsole()
			$__Amount__Startup_Console += 1
		EndIf
		Return RunWait(@ComSpec & " /c " & $szCommand, @WorkingDir, Default, 0x10)
	EndIf
	Return False
EndFunc   ;==>system